﻿// MKFLMP3.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#define _CRT_RAND_S
#include <stdio.h>
#include <tchar.h>
#include <ctype.h>
#include <mbctype.h>
#include <mbstring.h>
#include <memory.h>
#include <windows.h>
#include <time.h>
#include <locale.h>
#include <id3tag.h>			// ..\madplay\libid3tag-0.15.1b
#include "Fontx.h"


//#define		DIRLISTFILE				_T("\\DIRLSTWK.DAT")	// DIRコマンドの出力結果(dir /AD /ON /S /N /B) 
//#define		FILELISTFILE			_T("\\FILLSTWK.TXT")	// DIRコマンドの出力結果(dir /B /ON ディレクトリパス)
#define		HISTFILE16				_T("HIST16.DAT")		// 履歴ファイル(Version=16)
#define		VOLUMEFILE16			_T("VOLUME16.DAT")		// ボリュームファイル (Version=16)

#define		MAXLEN_DIRNAME			12			// DIR名長
#define		MAXLEN_DISPLAYNAME		32			// DIRの表示名長
#define		MAXLEN_TITLE			256			// 曲名の取得最大長(音源ファイルリストに出力する長さ(ML_TITLENAME)より大。取得値に含まれるアルバム名を切り捨てる可能性があるので。
#define		MAXLEN_DIRFULLPATH		128			// ディレクトリパスの最大UNICODE文字数
#define		MAXCHARS_DIRNAME		64			// ディレクトリの最大UNICODE文字数
#define		MAXCHARS_MP3_NAME		128			// MP3ファイルの最大UNICODE文字数

#define		BUFLEN					128
#define		MAX_DIRS				1000
#define		MAX_SUBDIRS				255			// １ディレクトリ下のサブディレクトリ数最大値
#define		MAX_MP3_FILES			255			// １ディレクトリ下のMP3ファイル数最大値
#define		NUM_RANDOMBYFILE		3			// ファイル単位でランダム再生するディレクトリの数


// DIR構成ファイル　レコード長・項目別バイトサイズ
#define	DIRSTRUCTUREFILE16				_T("DIRLST16.DAT")		// DIR構成ファイル(Version=16)
#define	RECLEN_DIRLIST					512UL		// イメージ部分を除くレコード長
#define DL_DISPLAYNAME_LEN				32			// ディレクトリ表示名のバイト数
#define DL_FULLDIR_LEN					258		
#define DL_FULLDIRBYTES_LEN				2
#define DL_DIRNAME_LEN					130
#define DL_RECNO_SUBDIR_START_LEN		2
#define DL_NUM_SUBDIR_LEN				1
#define DL_RECNO_PARENTDIR_LEN			2
#define DL_RECNO_GRANDPARENTDIR_LEN		2
#define DL_NUM_SNDFILE_LEN				1
#define DL_RECNO_SNDFILE_LEN			2
#define DL_FILLER_LEN					80
#define DL_IMAGEDATA_LEN				512
#define DL_IMAGEDATAHALF_LEN			256

// 音源ファイルリスト
#define	SNDFILELISTFILE					_T("SNDLST16.DAT")		// MP3ファイルリスト(Version=16)
#define	RECLEN_MP3LIST					352UL					// イメージ部分を除くレコード長
#define ML_TITLENAME_LEN				48
#define ML_FILENAME_LEN					258
#define ML_FILLER_LEN					46
#define ML_IMAGEDATA_LEN				768UL
#define ML_IMAGEDATAHALF_LEN			384UL

// ランダム再生順ファイル
#define	RANDOMORDERFILE					_T("RANDOM16.DAT")

// 固定文字列ファイル
#define	MESSAGESTRINGFILE				_T("MSGSTR16.DAT")
#define MS_IMAGEDATA_LEN				256UL
#define MS_IMAGEDATAHALF_LEN			128UL
#define	MS_SJIS_MAXLEN					16

// フォントファイル
#define	FONT_FILE_ZEN_16_16		_T("_FONT\\MYRCZ16B.FNT")
#define FONT_FILE_HAN_8_16		_T("_FONT\\MYRCH16B.FNT")

// ディレクトリ構成解析作業用
typedef struct _DirInfo {
	char*				dirname_mbs;			// ディレクトリ名（ディレクトリパスを含まない／マルチバイト）
	WCHAR*				dirname;				// ディレクトリ名（ディレクトリパスを含まない）
	USHORT				recno_thisdir;			// 本ディレクトリのレコード番号
	USHORT				recno_subdir_start;		// サブディレクトリの先頭レコード番号
	int					num_subdir;				// サブディレクトリ数
	struct _DirInfo*	subdirinfo;				// サブディレクトリ情報
	int					num_sndfile;			// 音源ファイル数
	USHORT				recno_sndfile;			// 音源ファイルリスト先頭レコード番号
	struct _DirInfo*	parentdirinfo;			// 親ディレクトリ情報
	int					randomunit;				// ランダム再生 再生単位
} DIRINFO;

// ランダム再生順決定作業用
typedef struct _RandomOrder {
	BYTE				unit;		// 再生単位　0:フォルダ単位、1:ファイル単位
	USHORT				recno_dir;	// ディレクトリレコード番号
	BYTE				trackno;	// 音源ファイルの曲番号
} RANDOMORDER;

USHORT		NumDirs;				// ディレクトリ総数(明細レコード総数)取得ワーク変数
USHORT		NumSndDirs;				// MP3ファイルを持つディレクトリ総数取得ワーク変数
USHORT		RecNoThisDir;			// ディレクトリのレコード番号採番ワーク変数
USHORT		RecNoSndFile;			// 音源ファイルのレコード番号採番ワーク変数
USHORT		NumRndItems;			// ランダム再生順項目数
RANDOMORDER	*RndOrderTable;			// ランダム再生順作成テーブル
WCHAR*		RandomByFile[NUM_RANDOMBYFILE];		// ファイル単位でランダム再生するディレクトリ


FONTMETRICS		FontZen_16_16;
FONTMETRICS		FontHan_8_16;

FILE* Fdl;		// DIR構成ファイル
FILE* Fml;		// 音源ファイル
FILE* Ftitle;	// 曲名リストファイル
FILE* Finf;		// タグ情報取得ファイル
_locale_t locale_Ja_Jp;

BOOL CreateDirectoryStructureFile();
BOOL GetSubDirInfo(LPCWSTR targetdirpath, DIRINFO* info);
void ConvertAltString(const WCHAR* orgStr, WCHAR* altStr);
BOOL ConvertWcsToMbs(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr);
BOOL ConvertWcsToMbs2(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr);
BOOL WriteDirStructureFileH();
BOOL WriteDirStructureFileRoot(DIRINFO* info);
BOOL WriteDirStructureFileM(LPCWSTR targetdirpath, DIRINFO* info);
int compare_dirinfo(const void* dir1, const void* dir2);
int compare_mp3filename(const void* file1, const void* file2);
void SetDirInfo(DIRINFO* info);
BOOL InitFont();
BOOL IsRandomByFileDir(LPCWSTR dirpath);
void CreateRandomOrder(DIRINFO* info);
int SetRandomOrderTable(DIRINFO* info, int idx);
void CreateMessageStringFile();
void getID3TagInfo(LPCWSTR inFolder, LPCWSTR mp3, WCHAR* title, int titlebufsize, int* titlelen);
void getID3TagInfoTest(FILE* fout, LPCWSTR inFolder, LPCWSTR mp3);


//int main(int argc, char *argv[])
int wmain(int argc, wchar_t* argv[])
{
	int		i;

	InitFont();

	if (argc > 1) {
		for (i = 1; i <= (argc-1); i++) {
			if (i > 3) break;
			RandomByFile[i-1] = (WCHAR*)malloc(sizeof(WCHAR) * 64);
			if (RandomByFile[i - 1] == NULL) break;
			_tcscpy_s(RandomByFile[i-1], 64, argv[i]);
		}
	}
	//RandomByFile[0] = (WCHAR*)malloc(sizeof(WCHAR) * 64);
	//_tcscpy_s(RandomByFile[0], 64, _T("\\Other genre"));

	if (_wfopen_s(&Fml, SNDFILELISTFILE, _T("wb")) != 0 || Fml == NULL) {
		printf("fopen error\n");
		return FALSE;
	}
	if (_wfopen_s(&Ftitle, _T("TITLE16.TXT"), _T("w")) != 0 || Ftitle == NULL) {	// MP3_16の動作に必須のファイルではない
		printf("fopen error\n");
		return FALSE;
	}	
	//if (_wfopen_s(&Finf, _T("TAGINF16.TXT"), _T("w")) != 0 || Finf == NULL) {	// MP3_16の動作に必須のファイルではない
	//	printf("fopen error\n");
	//	return FALSE;
	//}

	locale_Ja_Jp = _create_locale(LC_ALL, "ja-JP");
	CreateDirectoryStructureFile();
	fclose(Fml);
	fclose(Ftitle);
	//fclose(Finf);

	CreateMessageStringFile();
}


/*
 *	ディレクトリ構成ファイル作成
 */
BOOL CreateDirectoryStructureFile() {
	DIRINFO	rootdirinfo;

	RecNoSndFile = 0;
	NumRndItems = 0;

	// ルートディレクトリ
	memset(&rootdirinfo, 0, sizeof(DIRINFO));
	rootdirinfo.dirname = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
	if (rootdirinfo.dirname == NULL) return FALSE;
	_tcscpy_s(rootdirinfo.dirname, MAXCHARS_DIRNAME + 1, _T(""));
	rootdirinfo.dirname_mbs = (char *)malloc(DL_DISPLAYNAME_LEN + 1);
	if (rootdirinfo.dirname_mbs == NULL) return FALSE;
	ConvertWcsToMbs(rootdirinfo.dirname_mbs, DL_DISPLAYNAME_LEN + 1, rootdirinfo.dirname);

	// サブディレクトリ・ツリー
	GetSubDirInfo(_T(""), &rootdirinfo);
//	GetSubDirInfo(_T("D:"), &rootdirinfo);		// デバッグ実行時

	// ディレクトリ間連携情報設定
	RecNoThisDir = 1;
	rootdirinfo.recno_thisdir = RecNoThisDir++;
	SetDirInfo(&rootdirinfo);

	// ランダム再生順作成
	CreateRandomOrder(&rootdirinfo);

	printf("WriteDirStructureFileM\n");
	// DIR構成ファイル出力
	if (_wfopen_s(&Fdl, DIRSTRUCTUREFILE16, _T("wb")) != 0 || Fdl == NULL) {
		printf("fopen error\n");
		return FALSE;
	}
	WriteDirStructureFileH();
	WriteDirStructureFileRoot(&rootdirinfo);
	WriteDirStructureFileM(_T(""), &rootdirinfo);	// 明細レコード
	fclose(Fdl);

	return TRUE;
}


/*
 *	対象ディレクトリの下のサブディレクトリ情報を取得
 */
BOOL GetSubDirInfo(LPCWSTR targetdirpath, DIRINFO *info) {
	HANDLE	hFind;
	WIN32_FIND_DATA FindFileData;
	WCHAR	searchfile[MAXLEN_DIRFULLPATH];
	WCHAR*	mp3list[MAX_MP3_FILES];
	WCHAR*	titlelist[MAX_MP3_FILES];
	int		titlelen[MAX_MP3_FILES];
	int		titlelen_min;
	int		title_start_idx;
	int		trackno_flg;
	//WCHAR	mp3fullpath[MAXLEN_DIRFULLPATH];
	int		num_dir = 0;
	int		num_mp3 = 0;
	int		i;
	int		j;
	static BYTE	imagedata[ML_IMAGEDATA_LEN];

	printf("GetSubDirInfo=[%s]\n", info->dirname_mbs);
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\*.*"), targetdirpath);
	if (IsRandomByFileDir(targetdirpath) == TRUE) {
		info->randomunit = 1;
		printf(" ファイル単位\n");
	}
	// 対象ディレクトリの下の全ディレクトリと全ファイルを列挙する
	hFind = FindFirstFileEx(searchfile, FindExInfoBasic, &FindFileData, FindExSearchNameMatch, NULL, 1);
	if (hFind != INVALID_HANDLE_VALUE) {
		info->num_subdir = 0;
		info->subdirinfo = (DIRINFO*)malloc(sizeof(DIRINFO) * MAX_SUBDIRS);
		if (info->subdirinfo == NULL) return FALSE;
		memset(info->subdirinfo, 0, sizeof(DIRINFO) * MAX_SUBDIRS);
		info->num_sndfile = 0;
		do {
			// ディレクトリ
			if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
				if (_tcscmp(FindFileData.cFileName, _T(".")) != 0 && _tcscmp(FindFileData.cFileName, _T("..")) != 0
						&& FindFileData.cFileName[0] != '_'
						&& _tcslen(FindFileData.cFileName) <= MAXCHARS_DIRNAME) {
					// ディレクトリ名(UNICODE)
					info->subdirinfo[num_dir].dirname = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					if (info->subdirinfo[num_dir].dirname == NULL) return FALSE;
					memset(info->subdirinfo[num_dir].dirname, 0, sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					_tcscpy_s(info->subdirinfo[num_dir].dirname, MAXCHARS_DIRNAME + 1, FindFileData.cFileName);
					// ディレクトリ名(MBS)
					info->subdirinfo[num_dir].dirname_mbs = (char *)malloc(DL_DISPLAYNAME_LEN + 1);
					if (info->subdirinfo[num_dir].dirname_mbs == NULL) return FALSE;
					if (_tcsnicmp(info->subdirinfo[num_dir].dirname, _T("disk"), 4) == 0 ||
						_tcsnicmp(info->subdirinfo[num_dir].dirname, _T("disc"), 4) == 0) {		// disk/discで始まるディレクトリ名は、その親ディレクトリ名を繋いで表示名とする
						WCHAR	dirname_tmp[DL_DIRNAME_LEN];
						swprintf_s(dirname_tmp, DL_DIRNAME_LEN, _T("%s|%s"), info->subdirinfo[num_dir].dirname, info->dirname);
						ConvertWcsToMbs(info->subdirinfo[num_dir].dirname_mbs, DL_DISPLAYNAME_LEN + 1, dirname_tmp);
					}
					else {
						ConvertWcsToMbs(info->subdirinfo[num_dir].dirname_mbs, DL_DISPLAYNAME_LEN + 1, info->subdirinfo[num_dir].dirname);
					}
					// 
					num_dir++;
					NumDirs++;
				}
			}
			// ファイル
			else if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE){
				WCHAR*	c;
				c = wcsrchr(FindFileData.cFileName, '.');
				if (c != NULL) {
					if (_wcsicmp(c, _T(".mp3")) == 0 && _tcslen(FindFileData.cFileName) <= MAXCHARS_MP3_NAME) {
						if (num_mp3 < MAX_MP3_FILES) {
							// MP3ファイル名(UNICODE)
							mp3list[num_mp3] = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
							if (mp3list[num_mp3] == NULL) return FALSE;
							//memset(mp3list[num_mp3], 0, sizeof(WCHAR) * MAX_PATH);
							_tcscpy_s(mp3list[num_mp3], MAX_PATH, FindFileData.cFileName);
							// TEST
							//swprintf_s(mp3fullpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, FindFileData.cFileName);
							//fwrite(mp3fullpath, sizeof(WCHAR), 128, Ftitle);
							num_mp3++;
							if (num_mp3 == 1) {
								NumSndDirs++;
							}
							if (info->randomunit == 0) {	// ディレクトリ単位のランダム再生
								if (num_mp3 == 1) {
									NumRndItems++;
								}
							}
							else {		// 曲単位のランダム再生
								NumRndItems++;
							}
						}
					}
				}
			}
		} while (FindNextFileW(hFind, &FindFileData));

		FindClose(hFind);

		// サブディレクトリをソート
		if (num_dir > 0) {
			qsort(info->subdirinfo, num_dir, sizeof(DIRINFO), compare_dirinfo);
			for (i = 0; i < num_dir; i++) {
				info->subdirinfo[i].parentdirinfo = info;
			}
		}
		// ファイルをソート
		if (num_mp3 > 0) {
			info->recno_sndfile = RecNoSndFile;
			qsort(mp3list, num_mp3, sizeof(WCHAR*), compare_mp3filename);
		}
		info->num_subdir = num_dir;
		info->num_sndfile = num_mp3;

		// タグ情報からタイトル名取得
		titlelen_min = MAX_PATH;
		for (i = 0; i < num_mp3; i++) {
			titlelist[i] = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
			getID3TagInfo(targetdirpath, mp3list[i], titlelist[i], MAX_PATH, &titlelen[i]);
			//printf(" titlelen=%d\n", titlelen[i]);
			if (titlelen[i] < titlelen_min) titlelen_min = titlelen[i];		// タイトル文字数の最小値

			//getID3TagInfoTest(Finf, targetdirpath, mp3list[i]);
		}
		//printf(" titlelen_min=%d\n", titlelen_min);
		title_start_idx = 0;
		trackno_flg = 0;
		if (num_mp3 > 0 && titlelen_min > 0) {		// 全ての曲についてタグからタイトルを取得できた
			int		n;
			WCHAR	c;
			for (i = 0; i < titlelen_min; i++) {
				c = titlelist[0][i];				// １曲目のi番目の文字
				for (j = 1; j < num_mp3; j++) {		// ２曲目以降の同位置の文字と比較
					if (titlelist[j][i] != c) break;
				}
				if (j < num_mp3) {		// 一致しない文字がある
					// i番目の文字から不一致。 0～(i-1)番目の文字は全ての曲で一致している
					title_start_idx = i;
					break;
				}
			}
			//printf(" title_start_idx=%d\n", title_start_idx);
			
			// タイトル名から一致部分を除いて、タイトル名とする
			if (title_start_idx > 0) {
				for (i = 0; i < num_mp3; i++) {
					WCHAR* titlelist_work = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
					wcscpy_s(titlelist_work, MAX_PATH, &titlelist[i][title_start_idx]);
					free(titlelist[i]);
					titlelist[i] = titlelist_work;
					titlelen[i] -= title_start_idx;
				}
			}

			// タイトルに最初から曲番号がついているかどうかを判定する
			n = (num_mp3 < 10 ? num_mp3 : 9);		// 最初の最大９曲で判定
			for (i = 0; i < n; i++) {
				if (titlelist[i][0] != ('1' + i)){
					break;
				}
			}
			if (i >= n) {	
				trackno_flg = 1;		// タイトルに曲番号付き
			}
			else {
				// ２ケタの曲番号をチェック
				for (i = 0; i < n; i++) {
					if (!(titlelist[i][0] == '0' && titlelist[i][1] == ('1' + i))) {
						break;
					}
				}
				if (i >= n) {
					trackno_flg = 1;		// タイトルに曲番号付き
				}
			}
		}

		// 音源ファイルリストに出力
		fprintf(Ftitle, "DIR [%s]\n", info->dirname_mbs);
		for (i = 0; i < num_mp3; i++) {
			char	mp3file_mbs[ML_TITLENAME_LEN + 1];
			char	mp3file_mbs_2[ML_TITLENAME_LEN + 1];
			int		len_2 = 0;

			// 表示タイトル名
			ConvertWcsToMbs(mp3file_mbs, ML_TITLENAME_LEN + 1, mp3list[i]);		// ファイル名のSJIS
			if (trackno_flg == 0 && titlelen[i] > 0) {		// タイトルに曲番号なし
				WCHAR	title_tmp[MAX_PATH];

				swprintf_s(title_tmp, MAX_PATH, _T("%d %s"), i+1, titlelist[i]);	// 曲番号付加
				if (ConvertWcsToMbs(mp3file_mbs_2, ML_TITLENAME_LEN + 1, title_tmp) == TRUE) {
					fwrite(mp3file_mbs_2, 1, ML_TITLENAME_LEN, Fml);
					fprintf(Ftitle, "[%s][%s]\n", mp3file_mbs, mp3file_mbs_2);
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATAHALF_LEN, imagedata + ML_IMAGEDATAHALF_LEN, ML_IMAGEDATAHALF_LEN, (unsigned char*)mp3file_mbs_2, ML_TITLENAME_LEN, &FontHan_8_16, &FontZen_16_16);
				}
				else {
					fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATAHALF_LEN, imagedata + ML_IMAGEDATAHALF_LEN, ML_IMAGEDATAHALF_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &FontHan_8_16, &FontZen_16_16);
					fprintf(Ftitle, "[%s]\n", mp3file_mbs);
				}

			}
			else if (trackno_flg == 1 && titlelen[i] > 2) {		// タイトル名が曲番だけ、という名前は除外する
				if (ConvertWcsToMbs(mp3file_mbs_2, ML_TITLENAME_LEN + 1, titlelist[i]) == TRUE) {
					fwrite(mp3file_mbs_2, 1, ML_TITLENAME_LEN, Fml);
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATAHALF_LEN, imagedata + ML_IMAGEDATAHALF_LEN, ML_IMAGEDATAHALF_LEN, (unsigned char*)mp3file_mbs_2, ML_TITLENAME_LEN, &FontHan_8_16, &FontZen_16_16);
					fprintf(Ftitle, "[%s][%s]\n", mp3file_mbs, mp3file_mbs_2);
				}
				else {
					fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATAHALF_LEN, imagedata + ML_IMAGEDATAHALF_LEN, ML_IMAGEDATAHALF_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &FontHan_8_16, &FontZen_16_16);
					fprintf(Ftitle, "[%s]\n", mp3file_mbs);
				}

			}
			else {
				fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);
				// イメージデータ作成（表示タイトル名に基づく）
				MakeLcdDataOfString(imagedata, ML_IMAGEDATAHALF_LEN, imagedata + ML_IMAGEDATAHALF_LEN, ML_IMAGEDATAHALF_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &FontHan_8_16, &FontZen_16_16);

				fprintf(Ftitle, "[%s]\n", mp3file_mbs);
			}
			// 実ファイル名
			fwrite(mp3list[i], 1, ML_FILENAME_LEN, Fml);
			for (int j = 0; j < ML_FILLER_LEN; j++) {
				fputc(0, Fml);
			}
			// イメージデータ出力
			fwrite(imagedata, 1, ML_IMAGEDATA_LEN, Fml);

			RecNoSndFile++;
			//free(mp3list[i]);
			//free(titlelist[i]);
		}

		// 再帰的にサブディレクトリ情報
		for (i = 0; i < num_dir; i++) {
			WCHAR	searchsubfile[MAXLEN_DIRFULLPATH];
			swprintf_s(searchsubfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, info->subdirinfo[i].dirname);
			GetSubDirInfo(searchsubfile, &(info->subdirinfo[i]));
		}
		// サブディレクトリ・ファイルどちらも持たないサブディスプレイを排除する
		for (i=0, j=0; i < num_dir; i++) {
			if (info->subdirinfo[i].num_subdir != 0 || info->subdirinfo[i].num_sndfile != 0) {
				if (i != j) {
					memcpy(&(info->subdirinfo[j]), &(info->subdirinfo[i]), sizeof(DIRINFO));
				}
				j++;
			}
		}
		info->num_subdir = j;
	}
	return TRUE;

}

/*
 *	DIR構成ファイルのレコード番号を決める
 */
void SetDirInfo(DIRINFO* info) {
	int		i;

	for (i = 0; i < info->num_subdir; i++) {
		info->subdirinfo[i].recno_thisdir = RecNoThisDir++;
		info->subdirinfo[i].parentdirinfo = info;
		if (info->subdirinfo[i].num_sndfile > 0) {
			printf("SetDirInfo %x %x, %x %x \n", info->subdirinfo[i].recno_thisdir, info->subdirinfo[i].recno_thisdir * 0x300,
				info->subdirinfo[i].recno_sndfile, info->subdirinfo[i].recno_sndfile * 0x400);
		}
	}
	if (info->num_subdir > 0) {
		info->recno_subdir_start = info->subdirinfo[0].recno_thisdir;
	}

	for (i = 0; i < info->num_subdir; i++) {
		SetDirInfo(&(info->subdirinfo[i]));
	}
}


/*
 *	ランダム再生順作成
 */
void CreateRandomOrder(DIRINFO* info) {
	int		idx = 0;
	unsigned int	rnumer1, rnumer2;
	int		total_loop;
	int		i;
	RANDOMORDER		w;
	FILE*	fp;

	RndOrderTable = (RANDOMORDER*)malloc(sizeof(RANDOMORDER) * NumRndItems);
	idx = SetRandomOrderTable(info, idx);
	total_loop = idx * 10;

//	for (i = 0; i < total_loop; i++) {
//		printf("RND-B %d, %x, %d\n", RndOrderTable[i].unit, RndOrderTable[i].recno_dir, RndOrderTable[i].trackno);
//	}
	for (i = 0; i < total_loop; i++) {
		rand_s(&rnumer1);
		rand_s(&rnumer2);
		rnumer1 %= idx;
		rnumer2 %= idx;

		memcpy(&w, &RndOrderTable[rnumer1], sizeof(RANDOMORDER));
		memcpy(&RndOrderTable[rnumer1], &RndOrderTable[rnumer2], sizeof(RANDOMORDER));
		memcpy(&RndOrderTable[rnumer2], &w, sizeof(RANDOMORDER));
	}
//	for (i = 0; i < total_loop; i++) {
//		printf("RND-A %d, %x, %d\n", RndOrderTable[i].unit, RndOrderTable[i].recno_dir, RndOrderTable[i].trackno);
//	}

	if (_wfopen_s(&fp, RANDOMORDERFILE, _T("wb")) != 0 || fp == NULL) {
		printf("fopen error\n");
	}
	for (i = 0; i < idx; i++) {
		fwrite(&(RndOrderTable[i].unit), 1, 1, fp);
		fwrite(&(RndOrderTable[i].recno_dir), 1, 2, fp);
		fwrite(&(RndOrderTable[i].trackno), 1, 1, fp);
	}
	fclose(fp);
}

int SetRandomOrderTable(DIRINFO* info, int idx) {
	if (info->num_sndfile > 0) {
		printf(" SetRandomOrderTable %d, %x %x, %x %x \n", info->randomunit, info->recno_thisdir, info->recno_thisdir * 0x300, info->recno_sndfile, info->recno_sndfile * 0x400);
		if (info->randomunit == 0) {
			RndOrderTable[idx].unit = 0;
			RndOrderTable[idx].recno_dir = info->recno_thisdir;
			RndOrderTable[idx].trackno = 0;
			idx++;
		}
		else {
			for (int i = 0; i < info->num_sndfile; i++) {
				RndOrderTable[idx].unit = 1;
				RndOrderTable[idx].recno_dir = info->recno_thisdir;
				RndOrderTable[idx].trackno = i;
				idx++;
			}
		}
	}

	for (int i = 0; i < info->num_subdir; i++) {
		idx = SetRandomOrderTable(&(info->subdirinfo[i]), idx);
	}

	return idx;
}
	

/*
 *	MBS文字列に変換できないUNICODE文字列について代替文字列を作成する
 */
void ConvertAltString(const WCHAR* orgStr, WCHAR* altStr) {
	int strLen = _tcslen(orgStr);
	int	i;
	int	retVal;
	char	dummy[4];

	for (i = 0; i < strLen; i++) {
		if (_wctomb_s_l(&retVal, dummy, 4, orgStr[i], locale_Ja_Jp) == 0) {	// 変換可能
			altStr[i] = orgStr[i];
		}
		else {
			altStr[i] = '?';
		}
	}
	altStr[strLen] = '\0';
}


/*
 *	UNICODE文字列をMBS文字列に変換。MBS文字列はバッファ末尾まで半角スペースで埋め、NULL終端とする。
 */
BOOL ConvertWcsToMbs(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr) {
	size_t	retVal;
	int		i;
	BOOL	nullFlg = FALSE;

	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, wcstr, sizeInBytes - 1, locale_Ja_Jp);
	if (retVal == 0) {
		WCHAR	altName[MAX_PATH];

		fprintf(Ftitle, "cannot convert \n");
		return FALSE;
		//ConvertAltString(wcstr, altName);
		//_wcstombs_s_l(&retVal, mbstr, sizeInBytes, altName, sizeInBytes - 1, locale_Ja_Jp);
		//if (retVal == 0) {
		//	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, _T("???"), sizeInBytes - 1, locale_Ja_Jp);
		//}
	}
	if (retVal == 0) return FALSE;
	for (i = retVal-1; i < sizeInBytes; i++) {
			if (i == (sizeInBytes - 1)) {
				mbstr[i] = 0;		// NULL終端
			}
			else {
				mbstr[i] = 0x20;	// space
			}
	}
	return TRUE;
}


/*
 *	UNICODE文字列をMBS文字列に変換。MBS文字列は半角スペースで埋めしないで、NULL終端とする。
 */
BOOL ConvertWcsToMbs2(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr) {
	size_t	retVal;
	int		i;
	BOOL	nullFlg = FALSE;

	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, wcstr, sizeInBytes - 1, locale_Ja_Jp);
	if (retVal == 0) {
		WCHAR	altName[MAX_PATH];

		//fprintf(Ftitle, "cannot convert \n");
		mbstr[0] = 0;		// NULL終端
		return FALSE;
		//ConvertAltString(wcstr, altName);
		//_wcstombs_s_l(&retVal, mbstr, sizeInBytes, altName, sizeInBytes - 1, locale_Ja_Jp);
		//if (retVal == 0) {
		//	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, _T("???"), sizeInBytes - 1, locale_Ja_Jp);
		//}
	}
	//if (retVal == 0) return FALSE;
	mbstr[retVal - 1] = 0;		// NULL終端
	//for (i = retVal - 1; i < sizeInBytes; i++) {
	//	if (i == (sizeInBytes - 1)) {
	//		mbstr[i] = 0;		// NULL終端
	//	}
	//	else {
	//		mbstr[i] = 0x20;	// space
	//	}
	//}
	return TRUE;
}

/*
 *	DIRINFOの配列をdirnameでソートするための比較関数
 */
int compare_dirinfo(const void* dir1, const void* dir2) {
	DIRINFO* dirinfo1 = (DIRINFO*)dir1;
	DIRINFO* dirinfo2 = (DIRINFO*)dir2;

	if (dirinfo1 != NULL && dirinfo2 != NULL) {
		return _tcscmp(dirinfo1->dirname, dirinfo2->dirname);
	}
	else if (dirinfo1 == NULL) {
		return +1;
	}
	else {
		return -1;
	}
}

/*
 *	MP3ファイル名ソートのための比較関数
 */
int compare_mp3filename(const void* file1, const void* file2) {
	WCHAR* pfile1 = *(WCHAR**)(file1);
	WCHAR* pfile2 = *(WCHAR**)(file2);

	if (pfile1 != NULL && pfile2 != NULL) {
		return _tcscmp(pfile1, pfile2);
	}
	else if (pfile1 == NULL || pfile2 == NULL) {
		return +1;
	}
	else {
		return -1;
	}
}

/*
 *	DIR構成ファイルヘッダレコード書き出し
 */
BOOL WriteDirStructureFileH() {
	time_t ltime;
	struct tm today;
	WCHAR	crdt[32];
	char	crdt_mbs[32];
	size_t	retVal;

	time(&ltime);
	_localtime64_s(&today, &ltime);
	swprintf_s(crdt, 32, _T("%04d%02d%02d%02d%02d%02d"), today.tm_year + 1900, today.tm_mon + 1, today.tm_mday, today.tm_hour, today.tm_min, today.tm_sec);
	wcstombs_s(&retVal, crdt_mbs, 32, crdt, 32);

	fwrite(&NumDirs, 1, 2, Fdl);
	fwrite(&NumSndDirs, 1, 2, Fdl);
	fwrite(crdt_mbs, 1, 14, Fdl);
	for (int j = 0; j < 494; j++) {
		fputc(0, Fdl);
	}
	for (int j = 0; j < DL_IMAGEDATA_LEN; j++) {
		fputc(0, Fdl);
	}

	return TRUE;
}

/*
 *	DIR構成ファイル明細ルートレコード書き出し
 */
BOOL WriteDirStructureFileRoot(DIRINFO* info) {
	WCHAR	dirfullpath[MAXLEN_DIRFULLPATH + 1];
	USHORT	uswork;
	int		i, j;

	fwrite(info->dirname_mbs, 1, DL_DISPLAYNAME_LEN, Fdl);
	swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH + 1, _T("\\"));
	fwrite(dirfullpath, 1, DL_FULLDIR_LEN, Fdl);
	uswork = _tcslen(dirfullpath) * sizeof(WCHAR);
	fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);
	fwrite(info->dirname, 1, DL_DIRNAME_LEN, Fdl);

	fwrite(&(info->recno_subdir_start), 1, DL_RECNO_SUBDIR_START_LEN, Fdl);
	fwrite(&(info->num_subdir), 1, DL_NUM_SUBDIR_LEN, Fdl);

	for (j = 0; j < DL_RECNO_PARENTDIR_LEN; j++) {
		fputc(0, Fdl);
	}
	for (j = 0; j < DL_RECNO_GRANDPARENTDIR_LEN; j++) {
		fputc(0, Fdl);
	}

	fwrite(&(info->num_sndfile), 1, DL_NUM_SNDFILE_LEN, Fdl);
	fwrite(&(info->recno_sndfile), 1, DL_RECNO_SNDFILE_LEN, Fdl);
	for (j = 0; j < DL_FILLER_LEN; j++) {
		fputc(0, Fdl);
	}

	// イメージデータ
	for (j = 0; j < DL_IMAGEDATA_LEN; j++) {
		fputc(0, Fdl);
	}

	return TRUE;
}


/*
 *	DIR構成ファイル明細レコード書き出し
 */
BOOL WriteDirStructureFileM(LPCWSTR currentdirpath, DIRINFO* info) {
	WCHAR	dirfullpath[MAXLEN_DIRFULLPATH + 1];
	int		i, j;
	USHORT	uswork;
	DIRINFO* dirinfo;
	BYTE	imagedata[DL_IMAGEDATA_LEN];

	for (i = 0; i < info->num_subdir; i++) {
		fwrite(info->subdirinfo[i].dirname_mbs, 1, DL_DISPLAYNAME_LEN, Fdl);
		swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH + 1, _T("%s\\%s"), currentdirpath, info->subdirinfo[i].dirname);
		fwrite(dirfullpath, 1, DL_FULLDIR_LEN, Fdl);
		uswork = _tcslen(dirfullpath) * sizeof(WCHAR);
		fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);
		fwrite(info->subdirinfo[i].dirname, 1, DL_DIRNAME_LEN, Fdl);

		fwrite(&(info->subdirinfo[i].recno_subdir_start), 1, DL_RECNO_SUBDIR_START_LEN, Fdl);
		fwrite(&(info->subdirinfo[i].num_subdir), 1, DL_NUM_SUBDIR_LEN, Fdl);

		dirinfo = info->subdirinfo[i].parentdirinfo;
		if (dirinfo != NULL) {
			fwrite(&(dirinfo->recno_thisdir), 1, DL_RECNO_PARENTDIR_LEN, Fdl);
			dirinfo = dirinfo->parentdirinfo;
			if (dirinfo != NULL) {
				fwrite(&(dirinfo->recno_thisdir), 1, DL_RECNO_GRANDPARENTDIR_LEN, Fdl);
			}
			else {
				for (j = 0; j < DL_RECNO_GRANDPARENTDIR_LEN; j++) {
					fputc(0, Fdl);
				}
			}
		}
		else {
			for (j = 0; j < DL_RECNO_PARENTDIR_LEN; j++) {
				fputc(0, Fdl);
			}
		}

		fwrite(&(info->subdirinfo[i].num_sndfile), 1, DL_NUM_SNDFILE_LEN, Fdl);
		fwrite(&(info->subdirinfo[i].recno_sndfile), 1, DL_RECNO_SNDFILE_LEN, Fdl);
		printf("WriteDirStructureFileM %x %x, %x %x \n", info->subdirinfo[i].recno_thisdir, info->subdirinfo[i].recno_thisdir * 0x300
			, info->subdirinfo[i].recno_sndfile, info->subdirinfo[i].recno_sndfile * 0x400);
		for (j = 0; j < DL_FILLER_LEN; j++) {
			fputc(0, Fdl);
		}

		// イメージデータ
		//_tprintf(_T("MakeLcdDataOfString \n"));
		MakeLcdDataOfString(imagedata, DL_IMAGEDATAHALF_LEN, imagedata + DL_IMAGEDATAHALF_LEN, DL_IMAGEDATAHALF_LEN, (unsigned char *)(info->subdirinfo[i].dirname_mbs), DL_DISPLAYNAME_LEN, &FontHan_8_16, &FontZen_16_16);
		fwrite(imagedata, 1, DL_IMAGEDATA_LEN, Fdl);
	}
	for (i = 0; i < info->num_subdir; i++) {
		swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), currentdirpath, info->subdirinfo[i].dirname);
		WriteDirStructureFileM(dirfullpath, &(info->subdirinfo[i]));
	}
	return TRUE;
}


/*
 *	固定文字列ファイルを作成
 */
void CreateMessageStringFile() {
	int		i;
	FILE*	fp;
	char	msg_mbs[MS_SJIS_MAXLEN + 1];
	BYTE	imagedata[MS_IMAGEDATA_LEN];
	static const WCHAR* msgtab[] = {
		//  "0123456789012345"
		_T("MP3_16")			// 0
		,_T("Speaker")
		,_T("Earphone")
		,_T("DIRLST ERR")
		,_T("SNDLST ERR")
		,_T("RANDOM ERR")		// 5
		,_T("MP3 ERR")
		,_T("No HISTFILE")
		,_T("[SELECT/RETURN]")
		//  "0123456789012345"
	};
	static const int nummsg = (sizeof(msgtab) / sizeof(msgtab[0]));

	if (_wfopen_s(&fp, MESSAGESTRINGFILE, _T("wb")) == 0 && fp != NULL) {
		for (i = 0; i < nummsg; i++) {
			ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, msgtab[i]);
			MakeLcdDataOfString(imagedata, MS_IMAGEDATAHALF_LEN, imagedata + MS_IMAGEDATAHALF_LEN, MS_IMAGEDATAHALF_LEN, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &FontHan_8_16, &FontZen_16_16);
			fwrite(imagedata, 1, MS_IMAGEDATA_LEN, fp);
		}

		fclose(fp);
	}

}


/*
 *	フォント情報取得
 */
BOOL InitFont() {
	if (GetFontMetrics(FONT_FILE_ZEN_16_16, &FontZen_16_16) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_16_16);
		return FALSE;
	}
	if (GetFontMetrics(FONT_FILE_HAN_8_16, &FontHan_8_16) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_8_16);
		return FALSE;
	}
	_tprintf(_T("InitFont OK\n"));
	return TRUE;
}

/*
 *	指定されたディレクトリパスがランダム再生特定ディレクトリかどうかを判定
 *	ディレクトリフルパス(dirpath)が特定のフォルダパス(RandomByFile)から始まるかどうかで判定する。
 */
BOOL IsRandomByFileDir(LPCWSTR dirpath) {
	int		i;
	wchar_t* p;

	for (i = 0; i < NUM_RANDOMBYFILE; i++) {
		if (RandomByFile[i] != NULL) {
			p = (wchar_t*)_tcsstr(dirpath, RandomByFile[i]);
			//printf(" %ld %ld  [%lx] \n", p, dirpath, dirpath[0]);
			if (p == dirpath) {
				return TRUE;
			}
		}
	}

	return FALSE;
}

/*
 *	mp3ファイルのタグ情報から必要なものを取得
 *		title : 曲のタイトルをUTF16で取得する。末尾にNULL文字をセットする。
 *		titlebufsize : titleバッファの文字サイズ
 *		*titlelen : タイトルの文字数。タイトルを取得できないときはマイナス。
 *
 *	https://www.mars.org/mailman/public/mad-dev/2002-January/000439.html
 */
void getID3TagInfo(LPCWSTR inFolder, LPCWSTR mp3, WCHAR* title, int titlebufsize, int* titlelen) {
	WCHAR		mp3file[512];
	struct id3_file* id3_file;
	struct id3_tag* id3_tag;
	struct id3_frame* id3_frame;
	int			i, j, k;

	*titlelen = -1;

	swprintf_s(mp3file, 512, _T("%s\\%s"), inFolder, mp3);
	id3_file = id3_file_open_w(mp3file, ID3_FILE_MODE_READONLY);
	id3_tag = id3_file_tag(id3_file);
	for (i = 0; i < id3_tag->nframes; i++) {
		id3_frame = id3_tag->frames[i];
		if (id3_frame != NULL) {
			if (strcmp(id3_frame->id, ID3_FRAME_TITLE) == 0) {
				for (j = 0; j < id3_frame->nfields; j++) {
					union id3_field		id3_field;
					id3_field = id3_frame->fields[j];

					if (id3_field.type == ID3_FIELD_TYPE_STRINGLIST) {
						for (k = 0; k < id3_field_getnstrings(&id3_field); k++) {
							id3_ucs4_t const * ucs4_str = id3_field_getstrings(&id3_field, k);
							id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
							*titlelen = wcslen((wchar_t*)utf16_str);
							wcscpy_s(title, titlebufsize, (wchar_t*)utf16_str);
							free(utf16_str);
						}
					}
				}
			}
		}
	}
	id3_file_close(id3_file);
}

/*
 *	mp3ファイルのID3タグ情報を取得するテストプログラム
 *	(/usr/local/include/id3tag.h参照)
 *	https://www.mars.org/mailman/public/mad-dev/2002-January/000439.html
 */
void getID3TagInfoTest(FILE* fout, LPCWSTR inFolder, LPCWSTR mp3) {
	WCHAR		mp3file[512];
	struct id3_file* id3_file;
	struct id3_tag* id3_tag;
	struct id3_frame* id3_frame;
	char		utfbuf[512];
	char		sjisbuf[512];
	int			i, j, k;

	ConvertWcsToMbs2(sjisbuf, 512, mp3);		// ファイル名のSJIS
	fprintf(fout, "%s\n", sjisbuf);

	swprintf_s(mp3file, 512, _T("%s\\%s"), inFolder, mp3);
	id3_file = id3_file_open_w(mp3file, ID3_FILE_MODE_READONLY);
	id3_tag = id3_file_tag(id3_file);

	fprintf(fout, "id3_tag nframes=%d\n", id3_tag->nframes);
	for (i = 0; i < id3_tag->nframes; i++) {
		//signed long encoding = 0;
		fprintf(fout, " frames[%d]\n", i);
		id3_frame = id3_tag->frames[i];
		if (id3_frame != NULL) {
			//printf("%d ID=%s desc=%s nfields=%d\n", i, id3_frame->id, id3_frame->description, id3_frame->nfields);
			fprintf(fout, " ID=%s nfields=%d\n", id3_frame->id, id3_frame->nfields);
			for (j = 0; j < id3_frame->nfields; j++) {
				union id3_field		id3_field;
				id3_field = id3_frame->fields[j];

				fprintf(fout, "  fields[%d]\n", j);
				//printf(" field=%d id3_field_type=%d \n", j, id3_field.type);
				switch (id3_field.type) {
				case ID3_FIELD_TYPE_TEXTENCODING:
					fprintf(fout, "   ID3_FIELD_TYPE_TEXTENCODING value=%ld \n", id3_field.number.value); 
					//printf("value=%ld ", id3_field.number.value);
					//encoding = id3_field.number.value;	// encodingを覚えておく必要はない
					break;
				case ID3_FIELD_TYPE_LATIN1:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1 [%s]\n", (char *)id3_field.latin1.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_LATIN1 : %s\n", id3_field.latin1.ptr);
					break;
				case ID3_FIELD_TYPE_LATIN1FULL:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1FULL [%s]\n", (char *)id3_field.latin1.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_LATIN1FULL : %s\n", id3_field.latin1.ptr);
					break;
				case ID3_FIELD_TYPE_LATIN1LIST:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1LIST \n"); 
					for (k = 0; k < id3_field.latin1list.nstrings; k++) {
						fprintf(fout, "    [%s]\n", id3_field.latin1list.strings[k]);
					}
					break;
				case ID3_FIELD_TYPE_STRING:
					fprintf(fout, "   ID3_FIELD_TYPE_STRING [%s]\n", (char *)id3_field.string.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_STRING : %s\n", id3_field.string.ptr);
					{
						const id3_ucs4_t* ucs4_str = id3_field_getstring(&id3_field);
						//if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
						id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
						ConvertWcsToMbs2(sjisbuf, 512, (wchar_t *)utf16_str);
						fprintf(fout, "    [%s]\n", sjisbuf);
						free(utf16_str);
						//} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
						//	convUCS4toASCII(ucs4_str, sjisbuf, 128);
						//	fprintf(fout, " ID3_FIELD_TYPE_STRING : %s\n", sjisbuf);
						//}
					}
				break;
				case ID3_FIELD_TYPE_STRINGFULL:
					fprintf(fout, "   ID3_FIELD_TYPE_STRINGFULL [%s]\n", (char *)id3_field.string.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_STRINGFULL : %s\n", id3_field.string.ptr);
					{
						const id3_ucs4_t* ucs4_str = id3_field_getfullstring(&id3_field);
						//if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
						id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
						ConvertWcsToMbs2(sjisbuf, 512, (wchar_t*)utf16_str);
						fprintf(fout, "    [%s]\n", sjisbuf);
						free(utf16_str);
						//} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
						//	convUCS4toASCII(ucs4_str, sjisbuf, 128);
						//	fprintf(fout, " ID3_FIELD_TYPE_STRINGFULL : %s\n", sjisbuf);
						//}
					}
				break;
				case ID3_FIELD_TYPE_STRINGLIST:
					fprintf(fout, "   ID3_FIELD_TYPE_STRINGLIST nstrings=%d\n", id3_field.stringlist.nstrings);
					//printf("nstrings=%d ", id3_field.stringlist.nstrings);
					for (k = 0; k < id3_field_getnstrings(&id3_field) /*id3_field.stringlist.nstrings*/; k++) {
						const id3_ucs4_t* ucs4_str = id3_field_getstrings(&id3_field, k);
						//if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
						id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
						ConvertWcsToMbs2(sjisbuf, 512, (wchar_t*)utf16_str);
						fprintf(fout, "    [%d][%s]\n", i, sjisbuf);
						free(utf16_str);
						//} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
						//	printf("  convUCS4toASCII start\n");
						//	convUCS4toASCII(ucs4_str, sjisbuf, 128);
						//	printf("  convUCS4toASCII end\n");
						//	fprintf(fout, " ID3_FIELD_TYPE_STRINGLIST : %s\n", sjisbuf);
						//}
					}
					break;
				case ID3_FIELD_TYPE_LANGUAGE:
					fprintf(fout, "   ID3_FIELD_TYPE_LANGUAGE \n"); 
					/*
					{
						id3_ucs4_t *ucs4_str = id3_field.string.ptr;
						if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							iconvUTF16LEtoSJIS(utfbuf, 128, sjisbuf, 128);
							fprintf(fout, " ID3_FIELD_TYPE_LANGUAGE : %s\n", sjisbuf);
						} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
							convUCS4toASCII(ucs4_str, sjisbuf, 128);
							fprintf(fout, " ID3_FIELD_TYPE_LANGUAGE : %s\n", sjisbuf);
						}
					}
					*/
					break;
				case ID3_FIELD_TYPE_FRAMEID:
					fprintf(fout, "   ID3_FIELD_TYPE_FRAMEID \n");
					break;
				case ID3_FIELD_TYPE_DATE:
					fprintf(fout, "   ID3_FIELD_TYPE_DATE \n");
					break;
				case ID3_FIELD_TYPE_INT8:
					fprintf(fout, "   ID3_FIELD_TYPE_INT8 \n");
					break;
				case ID3_FIELD_TYPE_INT16:
					fprintf(fout, "   ID3_FIELD_TYPE_INT16 \n");
					break;
				case ID3_FIELD_TYPE_INT24:
					fprintf(fout, "   ID3_FIELD_TYPE_INT24 \n");
					break;
				case ID3_FIELD_TYPE_INT32:
					fprintf(fout, "   ID3_FIELD_TYPE_INT32 \n");
					break;
				case ID3_FIELD_TYPE_INT32PLUS:
					fprintf(fout, "   ID3_FIELD_TYPE_INT32PLUS \n");
					break;
				case ID3_FIELD_TYPE_BINARYDATA:
					fprintf(fout, "   ID3_FIELD_TYPE_BINARYDATA \n");
					break;
				}
				//printf(" \n");
			}
		}
	}
	fprintf(fout, "\n");

	id3_file_close(id3_file);
}


